library service;

import 'dart:convert';
import 'service_addon.dart';

class Service
{
  Service.parse(Map<String, dynamic> data)
  {
    _id = data["id"];
    category = data["category"];
    description = data["description"];
    name = data["name"];
    _durationMinutes = data["duration"];
    _price = data["price"];
    for (Map<String, dynamic> addon in data["addons"])
    {
      _addons.add(new ServiceAddon.parse(addon));
    }
  }

  Service.from(Service other)
  {
    _id = other._id;
    category = other.category;
    description = other.description;
    name = other.name;
    _durationMinutes = other._durationMinutes;
    _price = other.price;
    _addons = new List.from(other._addons);
  }

  String get toJSON
  {
    Map<String, dynamic> data;
    data["id"] = _id;
    data["category"] = category;
    data["description"] = description;
    data["name"] = name;
    data["duration"] = _durationMinutes;
    data["price"] = _price;
    data["addons"] = new List<Map<String, dynamic>>();
    for (ServiceAddon addon in _addons)
    {
      data["addons"].add(addon.properties);
    }

    return JSON.encode(data);
  }

  List<ServiceAddon> get addons => _addons;
  String get id => _id;
  int get durationMinutes => _durationMinutes;
  double get price => _price;

  List<ServiceAddon> _addons = new List();
  String _id;
  String category;
  String description;
  String name;
  int _durationMinutes;
  double _price;
}